<?php
session_start();
if ($_SESSION['uid'] == null) header("Location: index.php");
require_once 'functions.php';

if ($user['room'] != 61) {
    header("Location: main.php");
    die();
}
if ($user['battle'] != 0) {
    header('location: fight.php');
    die();
}

$status = 'Внимание! Моментальная оплата без подтверждения!';
$get = urldecode(filter_input(INPUT_SERVER, 'QUERY_STRING'));

function setProfession($name, $type, $needMoney, $needLevel)
{
    global $user;
    $profId = 0;
    if (!in_array($name, ['оружейник', 'наёмник', 'лекарь'])) return 'Такой профессии не существует!';
    if ($user['money'] < $needMoney) return 'Недостаточно денег!';
    if ($user['level'] < $needLevel) return 'Ваш уровень ещё мал для этой профессии!';
    if (!empty($user['prof1']) AND $type == 1) return 'Ошибка! У вас уже есть другая мирная профессия!';
    if (!empty($user['prof2']) AND $type == 2) return 'Ошибка! У вас уже есть другая боевая профессия!';
    if ($name == 'оружейник') $profId = 1;
    if ($name == 'наёмник') $profId = 21;
    if ($name == 'лекарь') $profId = 22;
    if (!empty($profId)) {
        try {
            db::c()->query('UPDATE `users` SET ?f = ?i, `money` = `money` - ?i WHERE `id` = ?i', 'prof' . $type, $profId, $needMoney, $_SESSION['uid']);
        } catch (\Krugozor\Database\Mysql\Exception $e) {
        }
        $deloText = "{$user['login']} купил профессию «{$name}» в академии за {$needMoney} кр.";
        addToDelo($deloText);
        $user['prof'.$type] = true;
        $user['money'] -= $needMoney;
        return 'Вы получили профессию!';
    } else return 'Что-то пошло не так...';
}

if ($get == 'smith') $status = setProfession('оружейник', 1, 300, 3);
if ($get == 'mercenary') $status = setProfession('наёмник', 2, 700, 5);
if ($get == 'medic') $status = setProfession('лекарь', 2, 700, 5);

if ($get == 'exit') {
    try {
        db::c()->query('UPDATE `users`,`online` SET `users`.`room` = 2702, `online`.`room` = 2702 WHERE `users`.`id` = ?i AND `online`.`id` = ?i', $_SESSION['uid'], $_SESSION['uid']);
    } catch (\Krugozor\Database\Mysql\Exception $e) {
    }
    header('Location: city.php');
}
?>
<!DOCTYPE html>
<html lang="ru">
<head>
    <meta charset="utf-8">
    <link href="css/main.css" rel="stylesheet">
    <link href="css/secondary.css" rel="stylesheet"/>
    <title></title>
</head>
<body>
<div style="float: right;">
    <button onclick="location.href='?exit'">Вернуться</button>
</div>
<h1>Академия</h1>
<div><?php if (!empty($status)) err($status); ?></div>
<div class="appblock appblock-main">
    <span class="legend">Информация</span>
    <span class="wrap">Кредиты<span class="num"><?= $user['money'] ?></span></span>
    <span class="wrap">Уровень персонажа<span class="num"><?= $user['level'] ?></span></span>
</div>
<div class="appblock">
    <span class="legend">Наёмник</span>
    <?php if (empty($user['prof2'])): ?>
        <button onclick="location.href='?mercenary'">Изучить профессию</button>
    <?php else: ?>
        <button style="color: darkred" disabled>У вас уже есть боевая профессия</button>
    <?php endif; ?>
    <span class="wrap">Цена<span class="num">700</span></span>
    <span class="wrap">Уровень персонажа<span class="num">5</span></span>
    <span class="wrap">
        Палач, это наёмник, который за деньги вмешивается в поединки других игроков не получая за это боевого опыта.
        Боевая профессия.
    </span>
</div>
<div class="appblock">
    <span class="legend">Лекарь</span>
    <?php if (empty($user['prof2'])): ?>
        <button onclick="location.href='?medic'">Изучить профессию</button>
    <?php else: ?>
        <button style="color: darkred" disabled>У вас уже есть боевая профессия</button>
    <?php endif; ?>
    <span class="wrap">Цена<span class="num">700</span></span>
    <span class="wrap">Уровень персонажа<span class="num">5</span></span>
    <span class="wrap">
        Лекарь лечит травмы, приобретённые игроками в боях и восстанавливает здоровье даже в поединке.
        Боевая профессия.
    </span>
</div>
<div class="appblock">
    <span class="legend">Колдун</span>
    <button disabled>Недоступно</button>
    <span class="wrap">Цена<span class="num">300</span></span>
    <span class="wrap">Уровень персонажа<span class="num">5</span></span>
    <span class="wrap">
        Колдун может встраивать руны в предметы, тем самым изменяя характеристики предмета. Мирная профессия.
    </span>
</div>
<div class="appblock">
    <span class="legend">Кузнец</span>
    <button disabled>Недоступно</button>
    <span class="wrap">Цена<span class="num">5000</span></span>
    <span class="wrap">Уровень персонажа<span class="num">10</span></span>
    <span class="wrap">
        Кузнец может создавать новые предметы используя расходные материалы. Мирная профессия.
    </span>
</div>
<div class="appblock">
    <span class="legend">Оружейник</span>
    <?php if (empty($user['prof1'])): ?>
        <button onclick="location.href='?smith'">Изучить профессию</button>
    <?php else: ?>
        <button style="color: darkred" disabled>У вас уже есть мирная профессия</button>
    <?php endif; ?>
    <span class="wrap">Цена<span class="num">300</span></span>
    <span class="wrap">Уровень персонажа<span class="num">5</span></span>
    <span class="wrap">
        Оружейник может точить оружие и подгонять броню, тем самым изменяя характеристики предмета. Мирная профессия.
    </span>
</div>
<div class="appblock">
    <span class="legend">Алхимик</span>
    <button disabled>Недоступно</button>
    <span class="wrap">Цена<span class="num">5000</span></span>
    <span class="wrap">Уровень персонажа<span class="num">10</span></span>
    <span class="wrap">
        Алхимик может создавать новые зелья используя расходные материалы. Мирная профессия.
    </span>
</div>
</body>
</html>